<?php
namespace Management\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;

class SetFilialSelecionada {
    
    const UPDATE_CDFILIALSELECIONADA = "
        UPDATE OPERADOR 
           SET CDFILIALSELECIONADA = :CDFILIAL 
         WHERE CDOPERADOR = :CDOPERADOR 
           AND NRORG = :NRORG";

    private $entityManager;
    private $environment;

    public function __construct(EntityManager $entityManager, Environment $environment) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
    }
    
    public function changeUserUnit($user) {
        $params = array(
            'NRORG' => $user['NRORG'],
            'CDFILIAL' => $user['CDFILIAL'],
            'CDOPERADOR' => $user['CDOPERADOR'],
        );

        $query = $this->entityManager->getConnection()->prepare(self::UPDATE_CDFILIALSELECIONADA);
        $query->execute($params);
        $this->environment->setCdFilial($user['CDFILIAL']);
    }
}