/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/* Nome: 0009_DENSTPO_USR_EXPORTATITU_DENADAI.sql                             */
/*                                                                            */
/* Descrio:                                                                 */
/* Procedure destinada a exportar informaes das vendas/ movimentos de caixa */
/* geradas no sistema da Teknisa para serem importadas no sistema Microsiga e,*/
/* para isso, a procedure alimentar uma tabela intermediria entre os dois   */
/* sistemas .(Tabelas pertencentes ao banco de dados do sistema da Microsiga).*/
/*                                                                            */
/* Criao: 20/08/2008 - Leonardo Matos                                       */
/******************************************************************************/

CREATE OR REPLACE
PROCEDURE USR_EXPORTATITU_DENADAI IS
   V_FILIAL  VARCHAR(10);
   V_TIPO    VARCHAR(3);
   V_CLIENTE VARCHAR(21);
   V_VALOR   FLOAT;
BEGIN
   FOR C_TITEXPORT IN
      (SELECT CDFILIAL, CDCAIXA, NRSEQVENDA, DTVENDA
         FROM VENDA
        WHERE NVL(USR_IDEXPORTA, 'S') = 'S'
          AND USR_DTEXPORTA IS NULL
        ORDER BY CDFILIAL, CDCAIXA, NRSEQVENDA
       )
   LOOP

   SELECT MAX(CDGRUPFILI)
     INTO V_FILIAL
     FROM FILGRUPFILI
    WHERE CDFILIAL = C_TITEXPORT.CDFILIAL
      AND USR_IDPROTHEUS = 'S';

   SELECT MAX(CDTIPORECE)
     INTO V_TIPO
     FROM MOVCAIXA
    WHERE CDFILIAL   = C_TITEXPORT.CDFILIAL
      AND CDCAIXA    = C_TITEXPORT.CDCAIXA
      AND NRSEQVENDA = C_TITEXPORT.NRSEQVENDA;

   SELECT SUM((QTPRODVEND * VRUNITVEND) + VRACRITVEND - VRDESITVEND) AS VRVALOR
     INTO V_VALOR
     FROM ITEMVENDA
    WHERE CDFILIAL   = C_TITEXPORT.CDFILIAL
      AND CDCAIXA    = C_TITEXPORT.CDCAIXA
      AND NRSEQVENDA = C_TITEXPORT.NRSEQVENDA;

   SELECT MAX(NRINSJURFILI)
     INTO V_CLIENTE
     FROM FILIAL
    WHERE CDFILIAL   = C_TITEXPORT.CDFILIAL;

    INSERT INTO USR_ZWC (
       WC_FILIAL , WC_PREFIXO,
       WC_NUM    , WC_TIPO   ,
       WC_CLIENTE, WC_EMISSAO,
       WC_VENCTO , WC_VENCREA,
       WC_VALOR  , WC_VLCRUZ ,
       WC_DTGRV  , WC_HRGRV  ,
       WC_DTIMP  , WC_HRIMP)
    VALUES
       (SUBSTR(V_FILIAL, 9, 2), 'PDV',
        C_TITEXPORT.CDFILIAL||C_TITEXPORT.CDCAIXA||C_TITEXPORT.NRSEQVENDA,  V_TIPO,
        V_CLIENTE, TO_CHAR(TRUNC(C_TITEXPORT.DTVENDA), 'DDMMYYYY'),
        TO_CHAR(TRUNC(C_TITEXPORT.DTVENDA), 'DDMMYYYY'), TO_CHAR(TRUNC(C_TITEXPORT.DTVENDA), 'DDMMYYYY'),
        V_VALOR, V_VALOR,
        TO_CHAR(TRUNC(SYSDATE), 'DDMMYYYY'), TO_CHAR(SYSDATE, 'HH24MI'),
        NULL,   '');
        
   UPDATE VENDA
      SET USR_IDEXPORTA = 'N',
          USR_DTEXPORTA = SYSDATE
    WHERE CDFILIAL    = C_TITEXPORT.CDFILIAL
      AND CDCAIXA     = C_TITEXPORT.CDCAIXA
      AND NRSEQVENDA  = C_TITEXPORT.NRSEQVENDA;

   END LOOP;
END;


-- VERSAO --
BEGIN ATUVEROBJ('USR_EXPORTATITU_DENADAI','5.03.011'); END;
/

