// FILE: ./assets/js/services/DashboardCorporativoService.js
function DashboardCorporativoService (restEngine) {
    
    this.setCards = function(filter) {
         return restEngine.post(
            'product#/getCards', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 60000
        );
    };
    
    this.setStripe = function(filter) {
         return restEngine.post(
            'product#/getStripe', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 5000
        );
    };
    
    this.setGraficos = function(filter) {
         return restEngine.post(
            'product#/getGraficos', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 120000
        );
    };
    
    this.setTables = function(filter) {
         return restEngine.post(
            'product#/getTables', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 120000
        );
    };
    
    this.setTablesCusto = function(filter) {
         return restEngine.post(
            'product#/getTablesCusto', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 60000
        );
    };
    
    this.setTypeGraficos = function(filter) {
         return restEngine.post(
            'product#/getTypeGraficos', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 60000
        );
    };
    
    this.setHelp = function(filter) {
         return restEngine.post(
            'product#/getHelp', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 5000
        );
    };
    
    this.setVisible = function() {
         return restEngine.post(
            'product#/getVisible', {
                'requestType': 'FilterData'
            }, undefined, undefined, undefined, undefined, 5000
        );
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('DashboardCorporativoService', DashboardCorporativoService);
});

/* global Configuration */
/* global getLocalVar */
/* global moment */

// FILE: ./assets/js/services/GRManageDashboardService.js
function GRManageDashboardService (restEngine) {
    
    this.getCaixaPendente = function() {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": getLocalVar('CDFILIAL')
            }
        ];

         return restEngine.post(
            'product#/getFechamentoCaixaPendente', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
    
    this.getConsolidacaoPendente = function() {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": getLocalVar('CDFILIAL')
            }
        ];

         return restEngine.post(
            'product#/getConsolidacaoVendaPendente', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
    
    this.getCupomPendente = function() {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": getLocalVar('CDFILIAL')
            }
        ];

         return restEngine.post(
            'product#/getFechamentoCupomPendente', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('GRManageDashboardService', GRManageDashboardService);
});

// FILE: ./assets/js/services/ManageDashboardService.js
function ManageDashboardService (restEngine) {
    
    this.getCaixaPendente = function() {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            }
        ];

         return restEngine.post(
            'product#/getFechamentoCaixaPendente', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
    
    this.getConsolidacaoPendente = function() {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            }
        ];

         return restEngine.post(
            'product#/getConsolidacaoVendaPendente', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
    
    this.getCupomPendente = function() {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": getLocalVar('CDOPERADOR')
            }
        ];

         return restEngine.post(
            'product#/getFechamentoCupomPendente', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
    
    this.getVendasDiarias = function(DTATUAL) {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": getLocalVar('CDFILIAL')
            },
            {
                "name": "DTENTRVENDA",
                "operator": "=",
                "value": DTATUAL
            }
        ];

        return restEngine.post(
            'product#/getVendasDiarias', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };

    this.getProdutosMaisVendidos = function(DTATUAL) {
        var filter = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            },
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": getLocalVar('CDFILIAL')
            },
            {
                "name": "DTENTRVENDA",
                "operator": "=",
                "value": DTATUAL
            }
        ];

        return restEngine.post(
            'product#/getProdutosMaisVendidos', {
                'requestType': 'FilterData',
                'filter': filter
            }, undefined, undefined, undefined, undefined, 8001000
        );
    };
    
    this.getDivergenciasConciliacao = function() {
        var data = [
            {
                'name': "NRORG",
                'operator': "=",
                'value': getLocalVar('NRORG')
            }
        ];
        
        return restEngine.post(
            'product#/getDivergenciasConciliacao', {
                'requestType': 'FilterData',
                'filter': data
            }, undefined, undefined, undefined, undefined, 8001000
        );  
    };
    
    // Util method to request modules redirect.
	this.requestModulesMetadata = function () {
		var modulesPackage = window.modulesPackage || "modules";
		return restEngine.requestMetaData(modulesPackage + "#json/modules.json").then(function (response) {
			return response.data;
		});
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ManageDashboardService', ManageDashboardService);
});

// FILE: ./assets/js/controllers/ChartController.js
function ChartController() {
 
    this.setWidgetChartSeries = function(widget, chartSeries) {
      widget.chartSeries = chartSeries;
    };
    
}

Configuration(function(ContextRegister) {
	ContextRegister.register('ChartController', ChartController);
});

/* global Configuration */
/* global getLocalVar */


// FILE: ./assets/js/controllers/ChartFactoryController.js
function ChartFactoryController() {
 
    this.getBarChart = function(color, serieFields, serieLabels, fieldSort, stacked) {
        
        if(!stacked)
            stacked = false;
            
        var chartSeries = {
                            "serieType": "bar",
                            "serieStacked": stacked,
                            "serieSort": fieldSort,
                            "serieColors": color,
                            "serieFields": serieFields,
                            "serieLabels": serieLabels,
                            "serieShowValueLabels": true,
                            "serieYAxisFormat": "currency"
                         };
                         
        return chartSeries;
    };
    
    this.getPieChart = function(color, nameLabel, valorLabel, fieldSort) {
      var chartSeries = {
							"serieType": "pie",
							"serieSort": fieldSort,
							"serieColors": color,
							"serieFieldLabel": nameLabel,
							"serieFieldValue": valorLabel,
							"serieShowValueLabels": false,
							"serieValueFormat": "currency"
						};
                         
        return chartSeries;
    };
    
    this.getDonutChart = function(nameLabel, valorLabel, fieldSort, color) {
      var chartSeries = {
							"serieType": "donut",
    						"serieSort": fieldSort,
    						"serieColors": color,
    						"serieFieldLabel": nameLabel,
    						"serieFieldValue": valorLabel,
    						"serieValueFormat": "currency"
						};
                         
        return chartSeries;
    };
    
    this.getAreaChart = function(nameLabel, valorLabel, color, marksize) {
      var chartSeries = {
                            "serieType": "area",
                            "serieStacked": false,
                            "serieLineType": "monotone",
                            "serieLineWidth": 0,
                            "serieColors": color,
                            "serieFields": valorLabel,
                            "serieLabels": nameLabel,
                            "serieYAxisFormat": "currency",
                            "serieLineMarkSize": marksize,
                            "serieShowValueLabels": false
                        };
                         
        return chartSeries;
    };
    
    this.getAreaChartDouble = function(nameLabel, valorLabel, color, marksize) {
      var chartSeries = {
                            "serieType": "area",
                            "serieStacked": false,
                            "serieLineType": "monotone",
                            "serieLineWidth": 0,
                            "serieColors": color,
                            "serieFields": valorLabel,
                            "serieLabels": nameLabel,
                            "serieYAxisFormat": "currency",
                            "serieLineMarkSize": marksize,
                            "serieShowValueLabels": false
                        };
                         
        return chartSeries;
    };
    
    this.getLineChart = function(nameLabel, valorLabel, serieLineWidth) {
      var chartSeries = {
                            "serieType": "line",
                            "serieStacked": false,
                            "serieLineType": "monotone",
                            "serieLineWidth": serieLineWidth,
                            "serieYAxisLinkedSerie": 0,
                            "serieColors": "#d81b60",
                            "serieFields": valorLabel,
                            "serieLabels": nameLabel,
                            "serieYAxisFormat": "currency",
                            "serieShowValueLabels": false,
                            "serieLineMarkSize": 6,
                            "serieLineMarkType": "circle"
                        };
                         
        return chartSeries;
    };
    
    this.getLineChartTriangle = function(nameLabel, valorLabel, serieLineWidth) {
      var chartSeries = {
                            "serieType": "line",
                            "serieStacked": false,
                            "serieLineType": "monotone",
                            "serieLineWidth": serieLineWidth,
                            "serieYAxisLinkedSerie": 0,
                            "serieColors": "#6D1A6A",
                            "serieFields": valorLabel,
                            "serieLabels": nameLabel,
                            "serieYAxisFormat": "currency",
                            "serieShowValueLabels": false,
                            "serieLineMarkSize": 10,
                            "serieLineMarkType": "triangle-up"
                        };
                         
        return chartSeries;
    };
    
    this.getProgressChart = function(valor, valorMaximo) {
      var chartSeries = {
							"serieType": "progress",
							"serieColors": "#1abc9c",
    						"serieValue": valor,
							"serieMaxValue": valorMaximo,
							"serieShowValueLabels": "%",
							"serieShowProgressValue": "value",
							"serieValueFormat": "currency"
						};
                         
        return chartSeries;
    };
    
}

Configuration(function(ContextRegister) {
	ContextRegister.register('ChartFactoryController', ChartFactoryController);
});

/* global Configuration */
/* global getLocalVar */

// FILE: ./assets/js/controllers/MainDashboardController.js
function MainDashboardController(eventAggregator, templateManager, ScreenService, restEngine, ChartFactoryController, ChartController) {

	var self = this;

	var EVENT_LOGIN_SUCCESS = 'onAllLocalVarsSetted';
	var SALES_CONCLUDED = 'salesConcluded';
	var SALES_CANCELED = 'salesCanceled';

	var LABEL_VENDAS_REALI = 'Vendas Realizadas/Dia';
	var LABEL_INFO_VND_UNI = 'Vendas Realizadas hoje - Por Unidade';
	var LABEL_INFO_VND_MOD = 'Vendas Realizadas por Modalidade/Dia';

	var LABEL_ACUMULAD_VND = 'Vendas Acumuladas/Dia';
	var LABEL_INFO_VND_ACM = 'Vendas realizadas hoje - Hora a Hora Acumuladas';

	var LABEL_PARTIC_VENDA = 'Venda por Unidade/Dia (Porcentagem)';

	var LABEL_CUMPRI_METAS = 'Vendas x Meta Acumulada';

	var LABEL_INFO_VND_TOT = 'Vendas realizadas hoje - Totalizado';
	var LABEL_INFO_TCK_UNI = 'Ticket Médio - Média Por Unidade';
	var LABEL_INFO_TCK_TOT = 'Ticket Médio - Média Geral';

	var TODAS_UNIDADES = 'T'; // Totalizado
	var POR_UNIDADE = 'S'; // Segmentado
	var MAIORES_VENDAS = 'M'; // Maior
	var POR_MODALIDADE = 'P'; // Por Unidade Por Modalidade
	
	var ICONCONFIG_VENDASDODIA = "back";
	var ICONCONFIG_VENDASTOTAL = "back";

	//eventAggregator.subscribe(EVENT_LOGIN_SUCCESS, initializeDashboardValues);

	//function initializeDashboardValues() {
	//	getDashboardData();
	//}


	// Number.prototype.isInt = function() {
	// 	return this % 1 === 0;
	// };

	Number.prototype.formatMoney = function(c, d, t) {
		var n = this;
			
			c = isNaN(c = Math.abs(c)) ? 2 : c;
			d = d == undefined ? "." : d;
			t = t == undefined ? "," : t;
			
		var	s = n < 0 ? "-" : "",
			i = String(parseInt(n = Math.abs(Number(n) || 0).toFixed(c))),
			j = (j = i.length) > 3 ? j % 3 : 0;
			
	 	return s + (j ? i.substr(0, j) + t : "") + i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : "");
	};

	// Number.prototype.toMoney = function() {
	// 	var treated = "";
	// 	var splited = this.toString().split('.');
	// 	if (parseFloat(this).isInt()) {
	// 		treated = this + ',00';
	// 	}
	// 	else if (parseFloat(splited[1]) < 10) {
	// 		splited[1] += '0';
	// 		treated = splited[0] + ',' + splited[1];
	// 	}
	// 	else {
	// 		treated = this;
	// 	}

	// 	treated = treated.replace('.', ',');
	// 	treated = 'R$ ' + treated;
	// 	return treated;
	// };
	/* Cuida do gráfico de vendas realizadas
	   Troca de acordo com a visualização solicitada.
	*/
	this.trocarGraficoVendasRealizadas = function(inicializacao) {

		var widget = getWidgetVendasRealizadas();
		var grafico;

		if (widget.unidades > 1 || inicializacao) {
			// Verifica se o gráfico está como Maior Venda ou como segmentado por unidade		
			if (widget.tipoVisualizacao == MAIORES_VENDAS) {

				widget.configButtonIcon = "";
				widget.label = LABEL_VENDAS_REALI;
				widget.labelInfo = LABEL_INFO_VND_UNI + " - Totalizado: R$ " + parseFloat(templateManager.container.allData.totalVendas[0].TOTALVEND.replace(',','.'));
				widget.tipoVisualizacao = POR_UNIDADE;

				widget.chartXAxisField = "LABELFILIAL";
				widget.chartXAxisTicksMaxLines = 10;
				widget.chartXAxisTicksMaxWidth = 65;
				widget.chartXAxisBandDimensionMinWidth = 60;


				grafico = [ChartFactoryController.getBarChart('#21634f', 'TOTALVEND', 'Total de Vendas', 'TOTALVEND'),
					ChartFactoryController.getLineChart('Meta Acumulada', 'META', 0)
				];

			}
			else if (widget.tipoVisualizacao == POR_UNIDADE) {

				widget.configButtonIcon = ICONCONFIG_VENDASDODIA;
				widget.label = LABEL_ACUMULAD_VND;
				widget.labelInfo = widget.currentRow.LABELFILIAL + " - Total vendido: R$ " + parseFloat(widget.currentRow.DADOSMETA[0].TOTALVEND.replace(',','.'));
				widget.tipoVisualizacao = MAIORES_VENDAS;

				widget.chartXAxisField = "DATA";
				widget.chartXAxisTicksMaxLines = 10;
				widget.chartXAxisTicksMaxWidth = 45;
				widget.chartXAxisBandDimensionMinWidth = 15;
				
				grafico = [ChartFactoryController.getAreaChart(['Total Vendido', 'Meta Acumulada'], ['TOTALVEND', 'META'], ["#66b9bf", "#eeaa7b"], 6),
					ChartFactoryController.getLineChartTriangle('Posição Atual', 'HORAATUAL', 0)
				];
			}


			self.inicializar(widget, grafico);
			self.inicializar(getWidgetDonutVendas(), trocarGraficoMeta());
		}

	};

	var trocarGraficoMeta = function(inicializacao) {

		var widget = getWidgetDonutVendas();
		var widgetVendas = getWidgetVendasRealizadas();
		var grafico;

		var serieFieldLabel = "LABELFILIAL";
		var serieFieldValue = "TOTALVEND";
		var serieSort;
		var serieColors;

		widget.tipoVisualizacao = "DONUTVENDAS";

		if (widgetVendas.tipoVisualizacao == POR_UNIDADE) {
			widget.label = LABEL_PARTIC_VENDA;
			widget.labelInfo = LABEL_INFO_VND_TOT + ": R$ " + parseFloat(templateManager.container.allData.totalVendas[0].TOTALVEND.replace(',','.'));
			setDonutVendas();

			serieSort = "value";
			serieColors = ["#80cbc4", "#00838f", "#0288d1", "#1e88e5", "#3f51b5", "#7e57c2"];

			grafico = [ChartFactoryController.getDonutChart(serieFieldLabel, serieFieldValue, serieSort, serieColors)];
		}
		else {
			var porcentagemUltrapassada;
			
			if (widgetVendas.currentRow.DADOSMETA[0].META > 0) 
				porcentagemUltrapassada = (widgetVendas.currentRow.DADOSMETA[0].TOTALVEND * 100) / widgetVendas.currentRow.DADOSMETA[0].META;
			else 
				porcentagemUltrapassada = widgetVendas.currentRow.DADOSMETA[0].TOTALVEND;
				
			widget.label = LABEL_CUMPRI_METAS;
			widget.labelInfo = widgetVendas.currentRow.LABELFILIAL + " - Meta acumulada: R$ " +  parseFloat((widgetVendas.currentRow.DADOSMETA[0].META + '').replace(',','.')) +
				". Porcentagem alcançada: " + parseFloat(porcentagemUltrapassada).toFixed(2) + "%";

			var cdfilial = widgetVendas.currentRow.LABELFILIAL.substring(0, 4);
			setDonutVendasMeta(cdfilial);

			serieColors = ["#1abc9c", "#e65100"];
			serieSort = false;

		}

		grafico = [ChartFactoryController.getDonutChart(serieFieldLabel, serieFieldValue, serieSort, serieColors)];

		return grafico;
	};

	this.trocarGraficoVendaModalidade = function(inicializacao) {

		var widget = getWidgetVendaModalidade();
		var grafico;
		var serieColors = ["#750568", "#80C8B5", "#4d62b7", "#E6C973", "#e673d4", "#6ae2dc"];
		var unidades = getWidgetVendasRealizadas().dataSourcePorUnidade.data.length;
		var tipoVisualizacao = widget.tipoVisualizacao;

		if (unidades > 1 || inicializacao) {
			if (tipoVisualizacao == TODAS_UNIDADES) {

				widget.tipoVisualizacao = POR_UNIDADE;
				widget.labelInfo = LABEL_INFO_VND_UNI;

				widget.chartXAxisField = "UNIDADE";

				var serieFields = ["MES", "BAL", "DLV", "TAA", "CMD", "OUTROS"];
				var serieLabels = ["Mesa", "Balcão", "Delivery", "TAA", "Comanda", "Outros"];

				grafico = [ChartFactoryController.getBarChart(serieColors, serieFields, serieLabels, 'value', true),
					ChartFactoryController.getLineChart('Meta do Dia', 'META', 0)
				];
				
				widget.configButtonIcon = ICONCONFIG_VENDASTOTAL;

			}
			else if (tipoVisualizacao == POR_UNIDADE) {

				widget.tipoVisualizacao = POR_MODALIDADE;

				widget.chartXAxisField = "MODALIDADE";
				serieColors = ["#3f9669"];

				grafico = [ChartFactoryController.getBarChart(serieColors, "TOTALVEND", "Total Vendas", 'TOTALVEND', false),
					ChartFactoryController.getLineChart('Meta', 'META', 0)
				];

				widget.configButtonIcon = ICONCONFIG_VENDASTOTAL;
			}
			else if (tipoVisualizacao == POR_MODALIDADE) {

				widget.tipoVisualizacao = TODAS_UNIDADES;
				widget.labelInfo = LABEL_INFO_VND_TOT + ": R$ " +  parseFloat(templateManager.container.allData.totalVendas[0].TOTALVEND.replace(',','.'));

				widget.chartXAxisField = "UNIDADE";

				serieColors = ["#6ae2dc", "#e673d4", "#E6C973", "#4d62b7", "#80C8B5", "#4f4860"];

				grafico = [ChartFactoryController.getPieChart(serieColors, 'MODALIDADE', 'TOTALVEND', 'TOTALVEND')];
				
				widget.configButtonIcon = "";
			}

			ChartController.setWidgetChartSeries(widget, grafico);
			setDataSourceCharts(widget);
			widget.updateChart();
			templateManager.updateTemplate();
		}

	};

	this.trocarGraficoTicketMedio = function(inicializacao) {
		var widget = getWidgetTicketMedio();
		var grafico;

		if (widget.unidades > 1 || inicializacao) {
			if (widget.tipoVisualizacao == TODAS_UNIDADES) {

				widget.tipoVisualizacao = POR_UNIDADE;
				widget.labelInfo = LABEL_INFO_TCK_UNI + " - Média geral: R$ " +  parseFloat(templateManager.container.allData.ticketMedio[0].TICKETMEDIO.replace(',','.'));

				grafico = [ChartFactoryController.getBarChart("#4db6ac", "TICKETMEDIO", "Ticket Médio", "value", false),
					ChartFactoryController.getLineChart('Meta', 'META', 0)
				];

			}
			else if (widget.tipoVisualizacao == POR_UNIDADE) {

				widget.tipoVisualizacao = TODAS_UNIDADES;
				widget.labelInfo = "Meta Ticket Médio: " + parseFloat(widget.dataSourcePorUnidade.data[0].META.replace(',','.'));

				widget.dataSource = {};
				
				if(widget.dataSourcePorUnidade.data[0].META == 0) {
					widget.dataSourcePorUnidade.data[0].META = widget.dataSourcePorUnidade.data[0].TICKETMEDIO;
				}

				grafico = [ChartFactoryController.getProgressChart(widget.dataSourcePorUnidade.data[0].TICKETMEDIO, widget.dataSourcePorUnidade.data[0].META)];
			}

			self.inicializar(widget, grafico);

		}
	};

	var getWidgetVendasRealizadas = function() {
		return templateManager.container.getWidget('VENDASREALIZADAS');
	};

	var getWidgetTicketMedio = function() {
		return templateManager.container.getWidget('TICKETMEDIO');
	};

	var getWidgetVendaModalidade = function() {
		return templateManager.container.getWidget('VENDAMODALIDADE');
	};

	var getWidgetDonutVendas = function() {
		return templateManager.container.getWidget('DONUTVENDAS');
	};

	var getDashboardData = function() {
		var data = [
			{
				'name': "NRORG",
				'operator': "=",
				'value': getLocalVar('NRORG')
			},
			{
				"name": "CDOPERADOR",
				"operator": "=",
				"value": getLocalVar('CDOPERADOR')
			},
			{
				"name": "DIASANTERIORES",
				"operator": "=",
				"value": templateManager.container.diasAnteriores
			},
			{
				"name": "DATAREGISTRO",
				"operator": "=",
				"value": templateManager.container.dashboardData
			}
		];

		if(!window.showMultipleFiliaisOnDashboard) {
			data.push(
				{
					"name": "CDFILIAL",
					"operator": "=",
					"value": getLocalVar('CDFILIAL')
				}
			);
		}

		restEngine.post(
			'product#/getDashboardData', {
				'requestType': 'FilterData',
				'filter': data
			}, undefined, undefined, undefined, undefined, 8001000
		).then(function(response) {
			templateManager.container.allData.status = response.dataset.status;
			if (templateManager.container.allData.status.STATUS != 100) {
				templateManager.container.allData.totalVendasDia = response.dataset.getQuantidadeVendasConcluidas[0].VENDAS;
				templateManager.container.allData.totalVendasCanceladasDia = response.dataset.getQuantidadeVendasCanceladas[0].VENDAS;
				templateManager.container.allData.totalVendasPorFilial = response.dataset.getTotalVendaFilial;
				templateManager.container.allData.totalVendas = response.dataset.getTotalVenda;
				templateManager.container.allData.ticketMedio = response.dataset.getTicketMedio;
				templateManager.container.allData.ticketMedioPorFilial = response.dataset.getTicketMedioFilial;
				templateManager.container.allData.vendaModalidade = response.dataset.getVendaModalidade;
				templateManager.container.allData.vendaModalidadePorFilial = response.dataset.getVendaModalidadeFilial;
				templateManager.container.allData.vendaHora = response.dataset.getVendaHora;
			} else {
				templateManager.container.getWidget(SALES_CONCLUDED).highlight =
				templateManager.container.getWidget(SALES_CANCELED).highlight = 0;
			}
			
			ScreenService.changeLoadingMessage("Aguarde...");
			setValoresWidgets();
		});
	};

	this.syncDashData = function() {
		ScreenService.changeLoadingMessage("Atualizando informações de vendas...");
		getDashboardData();
	
	};

	var setDataSourceCharts = function(widget) {
		var cdfilial;

		if (widget.tipoVisualizacao == POR_UNIDADE)
			widget.dataSource.data = widget.dataSourcePorUnidade.data;
		else if (widget.tipoVisualizacao == TODAS_UNIDADES)
			widget.dataSource.data = widget.dataSourceTotal.data;
		else if (widget.tipoVisualizacao == MAIORES_VENDAS) {
			cdfilial = widget.currentRow.LABELFILIAL.substring(0, 4);
			widget.dataSource.data = getValorVendidoUnidade(cdfilial);
		}
		else if (widget.tipoVisualizacao == POR_MODALIDADE) {

			widget.labelInfo = widget.currentRow.UNIDADE;

			if (widget.currentRow.UNIDADE)
				cdfilial = widget.currentRow.UNIDADE.substring(0, 4);
			else
				cdfilial = templateManager.container.allData.vendaModalidadePorFilial[0].CDFILIAL;
			setVendaModalidadeUnidade(cdfilial);

		}

		if (!!widget.chart)
			widget.chart.redraw();
	};

	var setValoresWidgets = function() {

		if (self.averiguarDataVendas() != 100) {
			setValorTotalQuantidadeVendasDia();
			setValorTotalQuantidadeVendasCanceladasDia();
			setValorChartVendaPorFilial();
			setValorChartVenda();
			setTicketMedioPorFilial();
			setVendaModalidade();
			setVendaModalidadePorFilial();
			setDonutVendas();
			self.inicializarGraficoModalidade();
			self.inicializarGraficoTicket();
			self.inicializarWidgetsValor();
			self.inicializarGraficoVenda();
		}

	};

	var setValorTotalQuantidadeVendasDia = function() {
		templateManager.container.getWidget(SALES_CONCLUDED).highlight = templateManager.container.allData.totalVendasDia;
	};

	var setValorTotalQuantidadeVendasCanceladasDia = function() {
		templateManager.container.getWidget(SALES_CANCELED).highlight = templateManager.container.allData.totalVendasCanceladasDia;
	};

	var setValorChartVendaPorFilial = function() {
		var widget = getWidgetVendasRealizadas();
		widget.dataSourcePorUnidade.data = templateManager.container.allData.totalVendasPorFilial;
		setDataSourceCharts(widget);
	};

	var setValorChartVenda = function() {
		var widget = getWidgetVendasRealizadas();
		widget.dataSourceTotal.data = templateManager.container.allData.totalVendas;
		setDataSourceCharts(widget);
	};

	var setTicketMedio = function() {
		var widget = getWidgetTicketMedio();
		var dados = templateManager.container.allData.ticketMedio;

		dados = [{
			"NOME": "Meta Geral",
			"VALOR": dados[0].META
		}, {
			"NOME": "Ticket Médio Geral",
			"VALOR": dados[0].TICKETMEDIO
		}];
		widget.dataSourceTotal.data = dados;

		setDataSourceCharts(widget);
	};

	var setTicketMedioPorFilial = function() {
		var widget = getWidgetTicketMedio();
		widget.dataSourcePorUnidade.data = templateManager.container.allData.ticketMedioPorFilial;
		setDataSourceCharts(widget);
	};

	var setVendaModalidade = function() {
		var widget = getWidgetVendaModalidade();

		var dadosModalidade = templateManager.container.allData.vendaModalidade;

		widget.dataSourceTotal.data = dadosModalidade;

		setDataSourceCharts(widget);
	};

	var setVendaModalidadeUnidade = function(cdfilial) {
		var widget = getWidgetVendaModalidade();

		widget.dataSource.data = findModalidade(cdfilial);
	};

	var findModalidade = function(cdfilial) {
		var dados = [];
		var modalidades = ["Mesa", "Balcão", "Delivery", "TAA", "Comanda", "Outros"];

		var vendas = templateManager.container.allData.vendaModalidadePorFilial;

		modalidades.forEach(function(data) {
			var info = {
				"UNIDADE": "Carregando",
				"TOTALVEND": 0,
				"MODALIDADE": data,
				"META": 0
			};
			dados.push(info);
		});

		vendas.forEach(function(data) {
			if (data.CDFILIAL == cdfilial) {
				dados.forEach(function(arrayDados) {
					arrayDados.UNIDADE = data.LABELFILIAL;
					if (arrayDados.MODALIDADE == data.MODALIDADE) {
						arrayDados.UNIDADE = data.LABELFILIAL;
						arrayDados.TOTALVEND = data.TOTALVEND;
						arrayDados.META = data.METAMODALIDADE;
					}
				});
			}
		});

		return dados;
	};

	var setVendaModalidadePorFilial = function() {
		var widget = getWidgetVendaModalidade();

		var dadosModalidade = templateManager.container.allData.vendaModalidadePorFilial;

		var arrayDados = [];
		var dadosReestruturados = {};

		dadosModalidade.forEach(function(data) {
			dadosReestruturados = {
				"UNIDADE": data.LABELFILIAL,
				"META": data.META,
				"MES": getValorVendidoModalidade('Mesa', data.CDFILIAL),
				"TAA": getValorVendidoModalidade('TAA', data.CDFILIAL),
				"DLV": getValorVendidoModalidade('Delivery', data.CDFILIAL),
				"BAL": getValorVendidoModalidade('Balcão', data.CDFILIAL),
				"CMD": getValorVendidoModalidade('Comanda', data.CDFILIAL),
				"OUTROS": getValorVendidoModalidade('Outros', data.CDFILIAL)
			};
			arrayDados.push(dadosReestruturados);
		});
		widget.dataSourcePorUnidade.data = arrayDados;
		setDataSourceCharts(widget);
	};

	var getValorVendidoModalidade = function(modalidade, filial) {
		var dadosModalidade;

		if (filial)
			dadosModalidade = templateManager.container.allData.vendaModalidadePorFilial;
		else
			dadosModalidade = templateManager.container.allData.vendaModalidade;

		var valor = 0;

		dadosModalidade.forEach(function(data) {
			if ((!!filial && (data.CDFILIAL === filial && data.MODALIDADE === modalidade)) || !filial && (data.MODALIDADE === modalidade)) {
				valor = data.TOTALVEND;
			}
		});

		return valor;
	};

	var getValorVendidoUnidade = function(filial) {
		var vendasHora;

		vendasHora = templateManager.container.allData.vendaHora;

		var valor = 0;

		vendasHora.forEach(function(data) {
			if (data.LABELFILIAL === filial) {
				valor = data.VENDAS;
			}
		});

		return valor;
	};

	var setDonutVendas = function() {
		var widget = getWidgetDonutVendas();
		widget.dataSource.data = templateManager.container.allData.totalVendasPorFilial;
		widget.chart.redraw();
	};

	var setDonutVendasMeta = function(cdfilial) {
		var widget = getWidgetDonutVendas();
		var dados = templateManager.container.allData.totalVendasPorFilial;

		dados.forEach(function(data) {
			if (data.CDFILIAL == cdfilial) {
				widget.dataSource.data = data.DADOSMETA;
			}
		});
		widget.chart.redraw();
	};

	this.inicializarGraficoModalidade = function() {
		var widget = getWidgetVendaModalidade();
		var unidades = getWidgetVendasRealizadas().dataSourcePorUnidade.data.length;

		if (unidades <= 1) {

			widget.tipoVisualizacao = POR_UNIDADE;
			self.trocarGraficoVendaModalidade(true);

		}
		else {
			widget.tipoVisualizacao = POR_MODALIDADE;
			self.trocarGraficoVendaModalidade();
		}
	};

	this.inicializarGraficoVenda = function() {
		var widget = getWidgetVendasRealizadas();
		var unidades = widget.dataSourcePorUnidade.data.length;

		if (unidades <= 1) {
			widget.currentRow = widget.dataSourcePorUnidade.data[0];
			widget.unidades = 1;
			widget.tipoVisualizacao = 'S';
		}
		else {
			widget.unidades = 2;
			widget.tipoVisualizacao = 'M';
		}
		self.trocarGraficoVendasRealizadas(true);
	};

	this.inicializarGraficoTicket = function() {
		var widget = getWidgetTicketMedio();
		var unidades = widget.dataSourcePorUnidade.data.length;

		widget.tipoVisualizacao = 'T';

		if (unidades <= 1) {
			widget.unidades = 1;
			widget.tipoVisualizacao = 'S';
		}

		self.trocarGraficoTicketMedio(true);
	};

	this.inicializarWidgetsValor = function() {
		var widVendascanceladas = templateManager.container.getWidget('salesCanceled');
		var widFcCupomPendentes = templateManager.container.getWidget('fechCupomPend');
		var widVendasNaoConsoli = templateManager.container.getWidget('vendasNaoConsolidadas');
		var widFechamentoPenden = templateManager.container.getWidget('fechCaixPend');

		widVendascanceladas.color =
			widFcCupomPendentes.color =
			widVendasNaoConsoli.color =
			widFechamentoPenden.color = "#b51313";

		if (templateManager.container.allData.totalVendasCanceladasDia == 0)
			widVendascanceladas.color = "#18b28a";
		if (widFcCupomPendentes.notification == 0)
			widFcCupomPendentes.color = "#18b28a";
		if (widVendasNaoConsoli.notification == 0)
			widVendasNaoConsoli.color = "#18b28a";
		if (widFechamentoPenden.notification == 0)
			widFechamentoPenden.color = "#18b28a";

		widVendascanceladas.redraw();
		widFcCupomPendentes.redraw();
		widVendasNaoConsoli.redraw();
		widFechamentoPenden.redraw();

		templateManager.updateTemplate();
	};

	this.inicializar = function(widget, grafico) {
		ChartController.setWidgetChartSeries(widget, grafico);
		setDataSourceCharts(widget);
		widget.updateChart();
		templateManager.updateTemplate();
	};

	this.averiguarDataVendas = function() {
		var dados = templateManager.container.allData.status;
		var dias = templateManager.container.diasAnteriores;

		if (dados.STATUS == 100) {
			if (dias == 0)
				ScreenService.errorNotification("Não foi possível recuperar nenhuma venda nos últimos 10 dias.", 60000, "");
			else
				ScreenService.errorNotification("Não foi possível recuperar nenhuma venda.", 60000, "");
		}
		else if (dados.STATUS == 300) {
			if (dados.DATA) {
				ScreenService.alertNotification("Exibindo vendas do dia " + dados.DATA + ".", 60000, "");
			}
			else
				ScreenService.alertNotification("Não foi possível recuperar as vendas de hoje.", 60000, "");
		}
		else if (dados.STATUS == 200) {
			if (templateManager.container.diasAnteriores < 0) {
				ScreenService.alertNotification("Exibindo vendas do dia " + dados.DATA + ".", 60000, "");
			}
			templateManager.container.diasAnteriores = 0;
		}

		templateManager.container.dashboardData = dados.DATA;
		return dados.STATUS;
	};

	this.getDiaAnterior = function() {
		var dados = templateManager.container.allData.status;
		if (dados.STATUS != 100) {
			templateManager.container.dashboardData = moment(templateManager.container.dashboardData, 'DD/MM/YY').subtract(1, "days").format('DD/MM/YY');
			templateManager.container.diasAnteriores--;
			verificarBotao();
			getDashboardData();
		}
		else {
			templateManager.container.diasAnteriores = 0;
			ScreenService.errorNotification("Não foi possível recuperar nenhuma venda.", 60000, "");
		}
	};

	this.getProxDia = function() {

		templateManager.container.diasAnteriores++;

		templateManager.container.dashboardData = moment(templateManager.container.dashboardData, 'DD/MM/YY').add(1, "days").format('DD/MM/YY');
		verificarBotao();
		getDashboardData();

	};

	var verificarBotao = function() {
		if (templateManager.container.diasAnteriores < 0) {
			templateManager.container.widgets[0].actions[2].isVisible = true;
		}
		else {
			templateManager.container.widgets[0].actions[2].isVisible = false;
		}
		templateManager.updateTemplate();
	};
	
	this.buttonConfig = function() {
		var widget = getWidgetVendasRealizadas();
		if (widget.unidades > 1 && widget.tipoVisualizacao == MAIORES_VENDAS) {
			this.trocarGraficoVendasRealizadas();
		}
	};
	
	this.buttonConfigVendaDiaModalidade = function() {
		var widget = getWidgetVendaModalidade();
		
		widget.tipoVisualizacao = POR_MODALIDADE;
		this.trocarGraficoVendaModalidade();
	};
}

Configuration(function(ContextRegister) {
	ContextRegister.register('MainDashboardController', MainDashboardController);
});

/* global Configuration */
/* global getLocalVar */
/* global moment */

// FILE: ./assets/js/controllers/ManageDashboardController.js
function ManageDashboardController (eventAggregator, templateManager, ScreenService, localStorageEngine, ManageDashboardService, MainDashboardController, GRManageDashboardService) {
    
    var   DASHBOARD_CONTAINER_NAME  = 'dashboard';
    
    // New event on engine.js -> After all localvars are set
    var   EVENT_LOGIN_SUCCESS    = 'onAllLocalVarsSetted';
    
    var   SALES_CONCLUDED           = 'salesConcluded',
          SALES_CANCELED            = 'salesCanceled',
          MOST_SOLD                 = 'mostSold',
          GRAFIC_PIE_MONTHLY        = 'graficPieMonthly',
          LIST_MONTHLY              = 'listMonthly',
          GRAFIC_PIE_DAILY          = 'graficPieDaily',
          LIST_DAILY                = 'listDaily',
          CAIXA_PENDENTE            = 'fechCaixPend',
          CUPOM_PENDENTE            = 'fechCupomPend',
          CONSOLIDACAO_PENDENTE     = 'vendasNaoConsolidadas';
    
    //eventAggregator.subscribe(EVENT_LOGIN_SUCCESS, initializeDashboardValues);
    
    // Initializing dashboards, according to new login and TekLib
    function initializeDashboardValues () {
        setDashboardCards();
        resizeScreen();
    }
    
    // Updates dashboard's card's values
    function setDashboardCards () {
        var DTATU = moment().format('DD/MM/YYYY');
        
        // Param for
        if(window.showMultipleFiliaisOnDashboard) {
            ManageDashboardService.getCaixaPendente().then(function(response) {
                templateManager.container.getWidget(CAIXA_PENDENTE).notification = response.dataset.getFechamentoCaixaPendente[0].COUNT;
            });
            
            ManageDashboardService.getCupomPendente().then(function(response) {
                templateManager.container.getWidget(CUPOM_PENDENTE).notification = response.dataset.getFechamentoCupomPendente[0].COUNT;
            }).then(resizeScreen);
            
            ManageDashboardService.getConsolidacaoPendente().then(function(response) {
                templateManager.container.getWidget(CONSOLIDACAO_PENDENTE).notification = response.dataset.getConsolidacaoVendaPendente[0].COUNT;
            });
        } else {
            GRManageDashboardService.getCaixaPendente().then(function(response) {
                templateManager.container.getWidget(CAIXA_PENDENTE).notification = response.dataset.getFechamentoCaixaPendente[0].COUNT;
            });
            
            GRManageDashboardService.getCupomPendente().then(function(response) {
                templateManager.container.getWidget(CUPOM_PENDENTE).notification = response.dataset.getFechamentoCupomPendente[0].COUNT;
            }).then(resizeScreen);
            
            GRManageDashboardService.getConsolidacaoPendente().then(function(response) {
                templateManager.container.getWidget(CONSOLIDACAO_PENDENTE).notification = response.dataset.getConsolidacaoVendaPendente[0].COUNT;
            });
        }
        
        handleCNCCard();
        
    }
    
    // Wait 10 seconds for Dashboard to load completely and update it
    var resizeScreen = function() {
        setTimeout(function() {
            $(window).resize();
            MainDashboardController.inicializarWidgetsValor();
        }, 3000);
    };
    
    // Redirect to CNC 
    this.redirectCncErrorLog = function (args) {
        localStorageEngine.setLocalVar("shouldNotShowFilter", true);
        
        this.openWindow('cnc#cnc02200_error_log');
    };
    
    
    this.updateNotificationsValue = function (widget) {
        if (!!widget.dataSource.data) 
            widget.notification = widget.dataSource.data.shift().COUNT;
    };
   
    // Shows CNC card and atributes to him backend's value
    var handleCNCCard = function () {
        var widget = templateManager.container.getWidget("cncConcErrosCard");
        
        return ManageDashboardService.getDivergenciasConciliacao().then(function(response) {
            widget.notification = response.dataset.findDivergenciasConciliacao[0].COUNT;
            widget.isVisible = (widget.notification > 0);
        });
        
    };
    
    // Using new TekLib method to redirect to modules correctly.  
    this.openWindow = function (windowName, newWindow) {
        ManageDashboardService.requestModulesMetadata().then(function (modules) {
            var subModule = windowName. split('#')[0];
            var module = subModule.split('_')[0];
            var url = window.location.origin + '/' + modules[module].baseUrl + "/#/" + windowName;
            if (ScreenService.openLink) {
                ScreenService.openLink(url, newWindow);
            } else {
                ScreenService.openWindow(windowName);
            }
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('ManageDashboardController', ManageDashboardController);
});

// FILE: ./assets/js/controllers/NewDashboardCorporativoController.js
function NewDashboardCorporativoController(eventAggregator, templateManager, ScreenService, localStorageEngine, DashboardCorporativoService, MainDashboardController, General, restEngine, ChartFactoryController, ChartController, metaDataFactory) {
    
    var DASHBOARD_CONTAINER_NAME = 'dashboard';
    
    var self = this;
    
    var LABEL_VENDAS_REALI = 'Vendas Realizadas/Dia';
	var LABEL_INFO_VND_UNI = 'Vendas Realizadas hoje - Por Unidade';
	var LABEL_INFO_VND_MOD = 'Vendas Realizadas por Modalidade/Dia';

	var LABEL_ACUMULAD_VND = 'Vendas Acumuladas/Dia';
	var LABEL_INFO_VND_ACM = 'Vendas realizadas hoje - Hora a Hora Acumuladas';

	var LABEL_PARTIC_VENDA = 'Venda por Unidade/Dia (Porcentagem)';

	var LABEL_CUMPRI_METAS = 'Vendas x Meta Acumulada';

	var LABEL_INFO_VND_TOT = 'Vendas realizadas hoje - Totalizado';
	var LABEL_INFO_TCK_UNI = 'Ticket Médio - Média Por Unidade';
	var LABEL_INFO_TCK_TOT = 'Ticket Médio - Média Geral';

	var TODAS_UNIDADES = 'T'; // Totalizado
	var POR_UNIDADE = 'S'; // Segmentado
	var MAIORES_VENDAS = 'M'; // Maior
	var POR_MODALIDADE = 'P'; // Por Unidade Por Modalidade
	
	var ICONCONFIG_VENDASDODIA = "back";
	var ICONCONFIG_VENDASTOTAL = "back";
	
	// New event on engine.js -> After all localvars are set
    var EVENT_LOGIN_SUCCESS = 'onAllLocalVarsSetted';
	
	eventAggregator.subscribe(EVENT_LOGIN_SUCCESS, initializeDashboardValues);
	
	// Initializing dashboards, according to new login and TekLib
    function initializeDashboardValues() {
        
        localStorageEngine.setLocalVar("DASHCDFILIAL", getLocalVar('CDFILIAL'));
        localStorageEngine.setLocalVar("DASHDATE", moment().format('DD/MM/YYYY'));
        localStorageEngine.setLocalVar("DASHCARD", false);
        localStorageEngine.setLocalVar("FILTERDASH", null);
        
        var widgetPrincipal = templateManager.container.getWidget('widDashboard');
        setTimeout(function (){
	        //getVisible
	        DashboardCorporativoService.setVisible().then(function (response) {
	            var container = templateManager.container;
	            var widgetVisible = response.dataset.getVisible;
	            
	            widgetVisible.forEach(function (cardWidget) {
	                var widget = container.getWidget(cardWidget.name);
	                widget.isVisible = cardWidget.visible;
	            },this);
	            
	            widgetPrincipal.redraw();
	        	templateManager.updateTemplate();
	        	widgetPrincipal.renderGrid(true);
		    },3000);
        	self.setTypeDashboard();
        });
    }
    
    this.setfilterini = function () {
        self.initializeActions(false, false);
    };
    
    this.openFilterPopUp = function () {
        var filterWidget = templateManager.container.getWidget('popupFilter');
        self.setLocalVarFilter(filterWidget);
        ScreenService.openPopup(filterWidget);
        filterWidget.activate();
    };
    
    this.cancelar = function (args) {
        var widget = args.owner.widget;
        var widgetPrincipal = templateManager.container.getWidget('widDashboard');
        ScreenService.closePopup();
        widgetPrincipal.activate();
        widgetPrincipal.reload();
        widget.fields.forEach(function (field) {
            field.value("");
        });
    };
    
    this.setDianterior = function () {
        self.initializeActions(true, false);
        self.startFilter(null);
    };
    
    this.setDiaProximo = function () {
        self.initializeActions(false, true);
        self.startFilter(null);
    };
    
    this.setLocalVarFilter = function(filterWidget2) {
        
        var filterWidget = filterWidget2;
        
        if(!filterWidget){
             filterWidget = templateManager.container.getWidget('popupFilter');   
        }
        
        filterWidget.currentRow.DTVNDCARDS = getLocalVar('DASHDATE');
           
        if (!filterWidget.currentRow.CDFILIAL) {
            filterWidget.currentRow.NMFILIAL = [getLocalVar('NMFILIAL')];
            filterWidget.currentRow.CDFILIAL = [getLocalVar('CDFILIAL')];
            filterWidget.getField('CDFILIAL').reload();
        }
    };
    
    // Initializing dashboards, according to new login and TekLib
    this.initializeActions = function (subtract, adition) {
        
        if(getLocalVar('DASHDATE') && (!subtract && !adition)){
            var DTVNDCARDS = moment(getLocalVar('DASHDATE'), 'DD/MM/YYYY').format('L');
        }else if(getLocalVar('DASHDATE') && (subtract && !adition)){
            var DTVNDCARDS = moment(getLocalVar('DASHDATE'), 'DD/MM/YYYY').subtract(1, 'days').format('L');
        }else if(getLocalVar('DASHDATE') && (!subtract && adition)){
            var DTVNDCARDS = moment(getLocalVar('DASHDATE'), 'DD/MM/YYYY').add(1, 'days').format('L');
        }else{
            var DTVNDCARDS = moment().format('L');
        }
        var present = moment().format('L');
        localStorageEngine.setLocalVar("DASHDATE", DTVNDCARDS);
        self.activeWigetPrincipal(present, DTVNDCARDS);
    }
    
    this.activeWigetPrincipal = function (present, DTVNDCARDS) {
        var widgetPrincipal = templateManager.container.getWidget('widDashboard');
        if (present == DTVNDCARDS) {
            widgetPrincipal.actions[1].isVisible = false;
        }else if(present != DTVNDCARDS){
            widgetPrincipal.actions[1].isVisible = true;
        }
        
        widgetPrincipal.activate();
        widgetPrincipal.reload().finally(function() {
            widgetPrincipal.renderGrid(true);
        });
        
    };
    
    this.startFilter = function (widgetFilter) {
        
        var widget = widgetFilter;
        var currentRowFilter = null;
        if(!widget){
             var CDFILIAL = getLocalVar('DASHCDFILIAL');
             var DTVNDCARDS = getLocalVar('DASHDATE');
        }else{
            var CDFILIAL = widget.currentRow.CDFILIAL ? widget.currentRow.CDFILIAL : getLocalVar('DASHCDFILIAL');
            var DTVNDCARDS = widget.currentRow.DTVNDCARDS ? widget.currentRow.DTVNDCARDS : getLocalVar('DASHDATE');    
            currentRowFilter = widget.currentRow;
        }
        
        localStorageEngine.setLocalVar("DASHCDFILIAL", CDFILIAL);
        localStorageEngine.setLocalVar("DASHDATE", DTVNDCARDS);
        localStorageEngine.setLocalVar("FILTERDASH", 'S');
        
        ScreenService.closePopup();
        self.initializeActions(false, false);
        self.setTypeDashboard();
        
    };
    
    this.filter = function (args) {
        var widget = args.owner.widget;
        self.startFilter(widget);
    };
    
    this.syncDashData = function() {
        self.setTypeDashboard();
	};
    
    // Set stripe values - Dashboard
    this.setStripe = function (filter){
        var stripeWidget = templateManager.container.getWidget("stripe");
        stripeWidget.currentRow.DATA = filter.DATA;
        stripeWidget.currentRow.FILIAL = filter.FILIAL;
        
        ScreenService.successNotification("Exibindo vendas com base do dia " + filter.DATA + ".", 6000, "");
    }
    
    // Updates dashboard's card's values
    this.setTypeDashboard = function () {
        var widgetPrincipal = templateManager.container.getWidget('widDashboard');
        var filterWidget = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": getLocalVar('DASHCDFILIAL') 
            },
            {
                "name": "DTVNDCARDS",
                "operator": "=",
                "value": getLocalVar('DASHDATE') 
            },
            {
                "name": "FILTERDASH",
                "operator": "=",
                "value": getLocalVar('FILTERDASH') 
            }
        ];
        
        
        //GetCards
        DashboardCorporativoService.setCards(filterWidget).then(function (response) {
            var container = templateManager.container;
            var widgetCards = response.dataset.getCards;
            
            widgetCards.forEach(function (cardWidget) {
                var widget = container.getWidget(cardWidget.name);
                widget.isVisible = cardWidget.visible;
                
                if(cardWidget.value){
                	widget.highlight = cardWidget.value;
	                widget.notification = cardWidget.value;
                }else{
                	
            		widget.highlight = cardWidget.value;
                	widget.notification = cardWidget.value;	
                	
                }
                
                if(cardWidget.color){
                    widget.color = cardWidget.color;    
                }
                
                if(cardWidget.message){
                    ScreenService.showMessage(cardWidget.message, cardWidget.typeMessage);    
                }
                
                widget.redraw();
                widget.reload();
            }, this);
            
            widgetPrincipal.redraw();
	        templateManager.updateTemplate();
	        widgetPrincipal.renderGrid(true);
            
        });
        
        //getGraficos
        DashboardCorporativoService.setTypeGraficos(filterWidget).then(function (response) {
            var container = templateManager.container;
            var widgetGraficosVisible = response.dataset.getInfos.graficos;
            var typeGraficoPadrao = response.dataset.getInfos.type;
            
            widgetGraficosVisible.forEach(function (cardWidget) {
                var widget = container.getWidget(cardWidget.name);
                widget.isVisible = cardWidget.visible;
            },this);
           
        	//setGraficos
            DashboardCorporativoService.setGraficos(filterWidget).then(function (response) {
                var container = templateManager.container;
                var widgetGraficos = response.dataset.getGraficos;
                
                widgetGraficos.forEach(function (cardWidget) {
                    var widget = container.getWidget(cardWidget.name);
                    
                    if(cardWidget.value){
                        //seta o objeto (values) para uma variavel
                        var objValues = cardWidget.value;
                        widget.dataSource.data = Object.values(objValues);    
                    }
                    	
                	if((cardWidget.name == 'VENDASREALIZADASP') && (cardWidget.allData)){
                		templateManager.container.allData.totalVendasPorFilial = cardWidget.allData.totalVendasPorFilial;
                    	templateManager.container.allData.totalVendas = cardWidget.allData.totalVendas;
						templateManager.container.allData.vendaHora = cardWidget.allData.vendaHora;
						widget.tipoVisualizacao = POR_UNIDADE;
                	}
                	
                	if((cardWidget.name == 'TICKETMEDIOP') && (cardWidget.allData)){
                		templateManager.container.allData.ticketMedio = cardWidget.allData.ticketMedio;
						templateManager.container.allData.ticketMedioPorFilial = cardWidget.allData.ticketMedioFilial;
                	}
                	
                	if((cardWidget.name == 'VENDAMODALIDADEP') && (cardWidget.allData)){
                		templateManager.container.allData.vendaModalidade = cardWidget.allData.vendaModalidade;
						templateManager.container.allData.vendaModalidadePorFilial = cardWidget.allData.vendaModalidadeFilial;
                	}
                	
                    widget.redraw();
                    widget.reload();
                },this);
                
                if(typeGraficoPadrao == 'P'){
                	setValoresWidgets();
                }
            });
            
            widgetPrincipal.redraw();
        	templateManager.updateTemplate();
        	widgetPrincipal.renderGrid(true);
            
        });
        
        //getTables
        DashboardCorporativoService.setTables(filterWidget).then(function (response) {
            var container = templateManager.container;
            var widgetTables = response.dataset.getTables;
            
            widgetTables.forEach(function (cardWidget) {
                var widget = container.getWidget(cardWidget.name);
                widget.isVisible = cardWidget.visible;
                
                if(cardWidget.value){
                	widget.dataSource.data = cardWidget.value;
                }
                
                widget.redraw();
                widget.reload();
                
            }, this);
            
            widgetPrincipal.redraw();
	        templateManager.updateTemplate();
	        widgetPrincipal.renderGrid(true);
        });
        
        //setStripe
        DashboardCorporativoService.setStripe(filterWidget).then(function (response) {
            //chama stripe para setar informacoes
            self.setStripe(response.dataset.getFilter);
        });
        
        widgetPrincipal.redraw();
        templateManager.updateTemplate();
        widgetPrincipal.renderGrid(true);
        
        //consultamaisdemoradas
        //getTablesCusto
        DashboardCorporativoService.setTablesCusto(filterWidget).then(function (response) {
            var container = templateManager.container;
            var widgetTablesCusto = response.dataset.getTablesCusto;
            
            widgetTablesCusto.forEach(function (cardWidget) {
                var widget = container.getWidget(cardWidget.name);
                widget.isVisible = cardWidget.visible;
                
                if(cardWidget.value){
                	widget.dataSource.data = cardWidget.value;
                }
                
                widget.redraw();
                widget.reload();
                
            }, this);
            
            widgetPrincipal.redraw();
	        templateManager.updateTemplate();
	        widgetPrincipal.renderGrid(true);
        });
        
    };
    
    //funcoes que sao dos graficos padrao
    
    /* Cuida do gráfico de vendas realizadas
	   Troca de acordo com a visualização solicitada.
	*/
	this.trocarGraficoVendasRealizadas = function(inicializacao) {

		var widget = getWidgetVendasRealizadas();
		var grafico;

		if (widget.unidades > 1 || inicializacao) {
			// Verifica se o gráfico está como Maior Venda ou como Segmentado por unidade		
			if (widget.tipoVisualizacao == MAIORES_VENDAS) {
				if (verifyMultipleEmpty(widget.currentRow)){
					widget.labelInfo = '';
				}
				else{
					widget.labelInfo = LABEL_INFO_VND_UNI + " - Totalizado: R$ " + parseFloat((templateManager.container.allData.totalVendas[0].TOTALVEND + '').replace(',','.'));

				}
				widget.configButtonIcon = "";
				widget.label = LABEL_VENDAS_REALI;
				widget.tipoVisualizacao = POR_UNIDADE;

				widget.chartXAxisField = "LABELFILIAL";
				widget.chartXAxisTicksMaxLines = 10;
				widget.chartXAxisTicksMaxWidth = 65;
				widget.chartXAxisBandDimensionMinWidth = 60;


				grafico = [ChartFactoryController.getBarChart('#21634f', 'TOTALVEND', 'Total de Vendas', 'TOTALVEND'),
					ChartFactoryController.getLineChart('Meta Acumulada', 'META', 0)
				];

			}
			else if (widget.tipoVisualizacao == POR_UNIDADE) {
				if (verifyMultipleEmpty(widget.currentRow)){
					widget.labelInfo = '';
				}
				else{
					widget.labelInfo = widget.currentRow.LABELFILIAL + " - Total vendido: R$ " + parseFloat((widget.currentRow.DADOSMETA[0].TOTALVEND  + '').replace(',','.'));

				}
				widget.configButtonIcon = ICONCONFIG_VENDASDODIA;
				widget.label = LABEL_ACUMULAD_VND;
				widget.tipoVisualizacao = MAIORES_VENDAS;

				widget.chartXAxisField = "DATA";
				widget.chartXAxisTicksMaxLines = 10;
				widget.chartXAxisTicksMaxWidth = 45;
				widget.chartXAxisBandDimensionMinWidth = 15;
				
				grafico = [ChartFactoryController.getAreaChart(['Total Vendido', 'Meta Acumulada'], ['TOTALVEND', 'META'], ["#66b9bf", "#eeaa7b"], 6),
					ChartFactoryController.getLineChartTriangle('Posição Atual', 'HORAATUAL', 0)
				];
			}


			self.inicializar(widget, grafico);
			self.inicializar(getWidgetDonutVendas(), trocarGraficoMeta());
		}

	};

	var trocarGraficoMeta = function(inicializacao) {

		var widget = getWidgetDonutVendas();
		var widgetVendas = getWidgetVendasRealizadas();
		var grafico;

		var serieFieldLabel = "LABELFILIAL";
		var serieFieldValue = "TOTALVEND";
		var serieSort;
		var serieColors;

		widget.tipoVisualizacao = "DONUTVENDAS";

		if (widgetVendas.tipoVisualizacao == POR_UNIDADE) {
			
			if (verifyMultipleEmpty(widgetVendas.currentRow)){
					widget.labelInfo = '';
			}
			else{
				widget.labelInfo = LABEL_INFO_VND_TOT + ": R$ " + parseFloat((templateManager.container.allData.totalVendas[0].TOTALVEND + '').replace(',','.'));

			}
			widget.label = LABEL_PARTIC_VENDA;
			setDonutVendas();

			serieSort = "value";
			serieColors = ["#80cbc4", "#00838f", "#0288d1", "#1e88e5", "#3f51b5", "#7e57c2"];

			grafico = [ChartFactoryController.getDonutChart(serieFieldLabel, serieFieldValue, serieSort, serieColors)];
		}
		else {
			var porcentagemUltrapassada;
			
			if (widgetVendas.currentRow.DADOSMETA[0].META > 0) 
				porcentagemUltrapassada = (widgetVendas.currentRow.DADOSMETA[0].TOTALVEND * 100) / widgetVendas.currentRow.DADOSMETA[0].META;
			else 
				porcentagemUltrapassada = widgetVendas.currentRow.DADOSMETA[0].TOTALVEND;
				
			if (verifyMultipleEmpty(widgetVendas.currentRow)){
					widget.labelInfo = '';
			}
			else {
				widget.labelInfo = widgetVendas.currentRow.LABELFILIAL + " - Meta acumulada: R$ " +  parseFloat((widgetVendas.currentRow.DADOSMETA[0].META + '').replace(',','.')) + ". Porcentagem alcançada: " + parseFloat(porcentagemUltrapassada).toFixed(2) + "%";
			}
			widget.label = LABEL_CUMPRI_METAS;


			var cdfilial = widgetVendas.currentRow.LABELFILIAL.substring(0, 4);
			setDonutVendasMeta(cdfilial);

			serieColors = ["#1abc9c", "#e65100"];
			serieSort = false;

		}

		grafico = [ChartFactoryController.getDonutChart(serieFieldLabel, serieFieldValue, serieSort, serieColors)];

		return grafico;
	};

	this.trocarGraficoVendaModalidade = function(inicializacao) {

		var widget = getWidgetVendaModalidade();
		var grafico;
		var serieColors = ["#750568", "#80C8B5", "#4d62b7", "#E6C973", "#e673d4", "#6ae2dc"];
		var unidades = getWidgetVendasRealizadas().dataSourcePorUnidade.data.length;
		var tipoVisualizacao = widget.tipoVisualizacao;

		if (unidades > 1 || inicializacao) {
			if (tipoVisualizacao == TODAS_UNIDADES) {

				widget.tipoVisualizacao = POR_UNIDADE;
				widget.labelInfo = LABEL_INFO_VND_UNI;

				widget.chartXAxisField = "UNIDADE";

				var serieFields = ["MES", "BAL", "DLV", "TAA", "CMD", "OUTROS"];
				var serieLabels = ["Mesa", "Balcão", "Delivery", "TAA", "Comanda", "Outros"];

				grafico = [ChartFactoryController.getBarChart(serieColors, serieFields, serieLabels, 'value', true),
					ChartFactoryController.getLineChart('Meta do Dia', 'META', 0)
				];
				
				widget.configButtonIcon = ICONCONFIG_VENDASTOTAL;

			}
			else if (tipoVisualizacao == POR_UNIDADE) {

				widget.tipoVisualizacao = POR_MODALIDADE;

				widget.chartXAxisField = "MODALIDADE";
				serieColors = ["#3f9669"];

				grafico = [ChartFactoryController.getBarChart(serieColors, "TOTALVEND", "Total Vendas", 'TOTALVEND', false),
					ChartFactoryController.getLineChart('Meta', 'META', 0)
				];

				widget.configButtonIcon = ICONCONFIG_VENDASTOTAL;
			}
			else if (tipoVisualizacao == POR_MODALIDADE) {

				widget.tipoVisualizacao = TODAS_UNIDADES;
				widget.labelInfo = LABEL_INFO_VND_TOT + ": R$ " +  parseFloat((templateManager.container.allData.totalVendas[0].TOTALVEND + '').replace(',','.'));

				widget.chartXAxisField = "UNIDADE";

				serieColors = ["#6ae2dc", "#e673d4", "#E6C973", "#4d62b7", "#80C8B5", "#4f4860"];

				grafico = [ChartFactoryController.getPieChart(serieColors, 'MODALIDADE', 'TOTALVEND', 'TOTALVEND')];
				
				widget.configButtonIcon = "";
			}

			ChartController.setWidgetChartSeries(widget, grafico);
			setDataSourceCharts(widget);
			widget.updateChart();
			templateManager.updateTemplate();
		}

	};

	this.trocarGraficoTicketMedio = function(inicializacao) {
		var widget = getWidgetTicketMedio();
		var grafico;

		if (widget.unidades > 1 || inicializacao) {
			if (widget.tipoVisualizacao == TODAS_UNIDADES) {

				widget.tipoVisualizacao = POR_UNIDADE;
				widget.labelInfo = LABEL_INFO_TCK_UNI + " - Média geral: R$ " +  parseFloat((templateManager.container.allData.ticketMedio[0].TICKETMEDIO + '').replace(',','.'));

				grafico = [ChartFactoryController.getBarChart("#4db6ac", "TICKETMEDIO", "Ticket Médio", "value", false),
					ChartFactoryController.getLineChart('Meta', 'META', 0)
				];

			}
			else if (widget.tipoVisualizacao == POR_UNIDADE) {

				widget.tipoVisualizacao = TODAS_UNIDADES;
				widget.labelInfo = "Meta Ticket Médio: " + parseFloat((widget.dataSourcePorUnidade.data[0].META + '').replace(',','.'));

				//widget.dataSource = {};
				
				if(widget.dataSourcePorUnidade.data[0].META == 0) {
					widget.dataSourcePorUnidade.data[0].META = widget.dataSourcePorUnidade.data[0].TICKETMEDIO;
				}

				grafico = [ChartFactoryController.getProgressChart(widget.dataSourcePorUnidade.data[0].TICKETMEDIO, widget.dataSourcePorUnidade.data[0].META)];
			}

			self.inicializar(widget, grafico);

		}
	};

	var getWidgetVendasRealizadas = function() {
		return templateManager.container.getWidget('VENDASREALIZADASP');
	};

	var getWidgetTicketMedio = function() {
		return templateManager.container.getWidget('TICKETMEDIOP');
	};

	var getWidgetVendaModalidade = function() {
		return templateManager.container.getWidget('VENDAMODALIDADEP');
	};

	var getWidgetDonutVendas = function() {
		return templateManager.container.getWidget('DONUTVENDAS');
	};
    
    var setDataSourceCharts = function(widget) {
		var cdfilial;
		
		if (widget.tipoVisualizacao == POR_UNIDADE)
			widget.dataSource.data = widget.dataSourcePorUnidade.data;
		else if (widget.tipoVisualizacao == TODAS_UNIDADES)
			widget.dataSource.data = widget.dataSourceTotal.data;
		else if (widget.tipoVisualizacao == MAIORES_VENDAS) {
			cdfilial = widget.currentRow.LABELFILIAL.substring(0, 4);
			widget.dataSource.data = getValorVendidoUnidade(cdfilial);
		}
		else if (widget.tipoVisualizacao == POR_MODALIDADE) {
			widget.labelInfo = widget.currentRow.UNIDADE;
			if (widget.currentRow.UNIDADE)
				cdfilial = widget.currentRow.UNIDADE.substring(0, 4);
			else
				cdfilial = templateManager.container.allData.vendaModalidadePorFilial[0].CDFILIAL;
			setVendaModalidadeUnidade(cdfilial);
		}
		
		widget.dataSource.data.map(parseFloatOnWidgetFields);
		
		if (!!widget.chart)
			widget.chart.redraw();
	};
	
	var verifyMultipleEmpty = function(row) {
		var filtro = getLocalVar('DASHCDFILIAL');
		
		if (row.VAZIO && filtro.length > 1){
			return true;
		}
		else{
			return false;
		}
	};
	
	var parseFloatOnWidgetFields = function(data) {
		if(data.hasOwnProperty('TOTALVEND')) {
			data.TOTALVEND = roundAndParseFloat(data.TOTALVEND);
		}
		if(data.hasOwnProperty('META')) {
			data.META = roundAndParseFloat(data.META);
		}
		if(data.hasOwnProperty('TICKETMEDIO')) {
			data.TICKETMEDIO = roundAndParseFloat(data.TICKETMEDIO);
		}
		if(data.hasOwnProperty('DADOSMETA')) {
			data.DADOSMETA.map(parseFloatOnWidgetFields);
		}
		
		return data;
	};
	
	var roundAndParseFloat = function(value) {
		return Math.round(( parseFloat(value) ) * 100) / 100;	
	};

	var setValoresWidgets = function() {
		setValorChartVendaPorFilial();
		setValorChartVenda();
		setDonutVendas();
		self.inicializarGraficoVenda();
		
		setVendaModalidade();
		setVendaModalidadePorFilial();
		self.inicializarGraficoModalidade();
		
		setTicketMedioPorFilial();
		self.inicializarGraficoTicket();
		
	};

	var setValorChartVendaPorFilial = function() {
		var widget = getWidgetVendasRealizadas();
		widget.dataSourcePorUnidade.data = templateManager.container.allData.totalVendasPorFilial;
		setDataSourceCharts(widget);
	};

	var setValorChartVenda = function() {
		var widget = getWidgetVendasRealizadas();
		widget.dataSourceTotal.data = templateManager.container.allData.totalVendas;
		setDataSourceCharts(widget);
	};

	var setTicketMedio = function() {
		var widget = getWidgetTicketMedio();
		var dados = templateManager.container.allData.ticketMedio;

		dados = [{
			"NOME": "Meta Geral",
			"VALOR": dados[0].META
		}, {
			"NOME": "Ticket Médio Geral",
			"VALOR": dados[0].TICKETMEDIO
		}];
		widget.dataSourceTotal.data = dados;

		setDataSourceCharts(widget);
	};

	var setTicketMedioPorFilial = function() {
		var widget = getWidgetTicketMedio();
		widget.dataSourcePorUnidade.data = templateManager.container.allData.ticketMedioPorFilial;
		setDataSourceCharts(widget);
	};

	var setVendaModalidade = function() {
		var widget = getWidgetVendaModalidade();
		var dadosModalidade = templateManager.container.allData.vendaModalidade;
		widget.dataSourceTotal.data = dadosModalidade;
		setDataSourceCharts(widget);
	};

	var setVendaModalidadeUnidade = function(cdfilial) {
		var widget = getWidgetVendaModalidade();

		widget.dataSource.data = findModalidade(cdfilial);
	};

	var findModalidade = function(cdfilial) {
		var dados = [];
		var modalidades = ["Mesa", "Balcão", "Delivery", "TAA", "Comanda", "Outros"];

		var vendas = templateManager.container.allData.vendaModalidadePorFilial;

		modalidades.forEach(function(data) {
			var info = {
				"UNIDADE": "Carregando",
				"TOTALVEND": 0,
				"MODALIDADE": data,
				"META": 0
			};
			dados.push(info);
		});

		vendas.forEach(function(data) {
			if (data.CDFILIAL == cdfilial) {
				dados.forEach(function(arrayDados) {
					arrayDados.UNIDADE = data.LABELFILIAL;
					if (arrayDados.MODALIDADE == data.MODALIDADE) {
						arrayDados.UNIDADE = data.LABELFILIAL;
						arrayDados.TOTALVEND = data.TOTALVEND;
						arrayDados.META = data.METAMODALIDADE;
					}
				});
			}
		});

		return dados;
	};

	var setVendaModalidadePorFilial = function() {
		var widget = getWidgetVendaModalidade();

		var dadosModalidade = templateManager.container.allData.vendaModalidadePorFilial;

		var arrayDados = [];
		var dadosReestruturados = {};

		dadosModalidade.forEach(function(data) {
			dadosReestruturados = {
				"UNIDADE": data.LABELFILIAL,
				"META": data.META,
				"MES": getValorVendidoModalidade('Mesa', data.CDFILIAL),
				"TAA": getValorVendidoModalidade('TAA', data.CDFILIAL),
				"DLV": getValorVendidoModalidade('Delivery', data.CDFILIAL),
				"BAL": getValorVendidoModalidade('Balcão', data.CDFILIAL),
				"CMD": getValorVendidoModalidade('Comanda', data.CDFILIAL),
				"OUTROS": getValorVendidoModalidade('Outros', data.CDFILIAL)
			};
			arrayDados.push(dadosReestruturados);
		});
		widget.dataSourcePorUnidade.data = arrayDados;
		setDataSourceCharts(widget);
	};

	var getValorVendidoModalidade = function(modalidade, filial) {
		var dadosModalidade;

		if (filial)
			dadosModalidade = templateManager.container.allData.vendaModalidadePorFilial;
		else
			dadosModalidade = templateManager.container.allData.vendaModalidade;

		var valor = 0;

		dadosModalidade.forEach(function(data) {
			if ((!!filial && (data.CDFILIAL === filial && data.MODALIDADE === modalidade)) || !filial && (data.MODALIDADE === modalidade)) {
				valor = data.TOTALVEND;
			}
		});

		return valor;
	};

	var getValorVendidoUnidade = function(filial) {
		var vendasHora;

		vendasHora = templateManager.container.allData.vendaHora;

		var valor = 0;
		if(vendasHora) {
			vendasHora.forEach(function(data) {
				if (data.LABELFILIAL === filial) {
					valor = data.VENDAS;
				}
				else{
					valor = [];
				}
			});
		}

		return valor;
	};

	var setDonutVendas = function() {
		var widget = getWidgetDonutVendas();
		widget.dataSource.data = templateManager.container.allData.totalVendasPorFilial;
		widget.chart.redraw();
	};

	var setDonutVendasMeta = function(cdfilial) {
		var widget = getWidgetDonutVendas();
		var dados = templateManager.container.allData.totalVendasPorFilial;

		dados.forEach(function(data) {
			if (data.CDFILIAL == cdfilial) {
				widget.dataSource.data = data.DADOSMETA;
			}
		});
		widget.chart.redraw();
	};

	this.inicializarGraficoModalidade = function() {
		var widget = getWidgetVendaModalidade();
		var unidades = getWidgetVendasRealizadas().dataSourcePorUnidade.data.length;

		if (unidades <= 1) {

			widget.tipoVisualizacao = POR_UNIDADE;
			self.trocarGraficoVendaModalidade(true);

		}
		else {
			widget.tipoVisualizacao = POR_MODALIDADE;
			self.trocarGraficoVendaModalidade();
		}
	};

	this.inicializarGraficoVenda = function() {
		var widget = getWidgetVendasRealizadas();
		var unidades = widget.dataSourcePorUnidade.data.length;

		if (unidades <= 1) {
			widget.currentRow = widget.dataSourcePorUnidade.data[0];
			widget.unidades = 1;
			widget.tipoVisualizacao = 'S';
		}
		else {
			widget.unidades = 2;
			widget.tipoVisualizacao = 'M';
		}
		self.trocarGraficoVendasRealizadas(true);
	};

	this.inicializarGraficoTicket = function() {
		var widget = getWidgetTicketMedio();
		var unidades = widget.dataSourcePorUnidade.data.length;

		widget.tipoVisualizacao = 'T';

		if (unidades <= 1) {
			widget.unidades = 1;
			widget.tipoVisualizacao = 'S';
		}

		self.trocarGraficoTicketMedio(true);
	};

	this.inicializar = function(widget, grafico) {
		ChartController.setWidgetChartSeries(widget, grafico);
		setDataSourceCharts(widget);
		widget.updateChart();
		//templateManager.updateTemplate();
	};

	this.buttonConfig = function() {
		var widget = getWidgetVendasRealizadas();
		if (widget.unidades > 1 && widget.tipoVisualizacao == MAIORES_VENDAS) {
			this.trocarGraficoVendasRealizadas();
		}
	};
	
	this.buttonConfigVendaDiaModalidade = function() {
		var widget = getWidgetVendaModalidade();
		
		widget.tipoVisualizacao = POR_MODALIDADE;
		this.trocarGraficoVendaModalidade();
	};
    
    //fim funcao dos graficos padrao

    
    // Redirect to CNC
    this.redirectCncErrorLog = function (args) {
        localStorageEngine.setLocalVar("shouldNotShowFilter", true);
        this.openWindow('cnc#cnc02200_error_log');
    };
    
    // Using new TekLib method to redirect to modules correctly.
    this.openWindow = function (windowName, newWindow) {
        localStorageEngine.setLocalVar("DASHCARD", true);
        requestModulesMetadata().then(function (modules) {
            var subModule = windowName.split('#')[0];
            var module = subModule.split('_')[0];
            var url = window.location.origin + '/' + modules[module].baseUrl + "/#/" + windowName;
            if (ScreenService.openLink) {
                ScreenService.openLink(url, newWindow);
            }
            else {
                ScreenService.openWindow(windowName);
            }
        });
    };
	    
    // Util method to request modules redirect.
    function requestModulesMetadata() {
        var modulesPackage = window.modulesPackage || "modules";
        return restEngine.requestMetaData(modulesPackage + "#json/modules.json").then(function (response) {
            return response.data;
        });
    }

    this.openModalExplicativo = function() {
        var widget = metaDataFactory.widgetFactory({
			"name": "modalExplicativo",
			"showAsModal": true,
			"label": ScreenService.i18n("Informações do Dashboard (Painel de Controle)"),
			"container": templateManager.container,
			"template": "widget/form.html",
			"showDescriptionOrder": false,
			"isVisible": true,
			"fields": [
				{
                    "label": "",
                    "name": "EXPLICACOES",
                    "isVisible": true,
                    "showOnView": true,
                    "readOnly": true,
                    "isVisibleOnReport": false,
                    "template": "field/textarea.html",
                    "class": 12,
                    "textRows": 20
                }
			],
			"events": [],
			"actions":[
				{
					"id": 1,
					"name": "canceladd",
					"label": ScreenService.i18n("Cancel"),
					"isVisible": true,
					"hideIcon": true,
					"showAsAction": "back",
					"events": [{
						"id": 1,
						"name": "ActionEvent",
						"code": "ScreenService.closePopup();"
					}]
				}
			]
        });
        
        var explicacao = "";
        
        //setHelp
        DashboardCorporativoService.setHelp().then(function (response) {
            //chama help para setar informacoes
            explicacao = response.dataset.getInfo.informacoes;
        	widget.getField('EXPLICACOES').setValue(explicacao);
        });
        
        ScreenService.openPopup(widget);
    };
    
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register('NewDashboardCorporativoController', NewDashboardCorporativoController);
});
